/******************************************************************************

	AUTHOR		: Axel Mueller
	
	ADDRESS		: Urbanstrasse 3, 73728 Esslingen, Germany

	Copyright (c) 2003, 2004 by Axel Mueller
	All rights reserved.

-------------------------------------------------------------------------------

	FILENAME	: StringFileFilter.java

	PROJECT		: 

	DESCRIPTION	: 

-------------------------------------------------------------------------------
	DATE		AUTHOR	DESCRIPTION OF CHANGES
	--------	------	-------------------------------------------------------
	04-03-02	AM		Initial version.
-------------------------------------------------------------------------------
	REMARKS		: 
******************************************************************************/

import java.io.File;
import java.io.FileFilter;
import java.util.regex.*;

public class StringFileFilter implements FileFilter {
	
	private String patternString = "";
	private Pattern pattern;
	
	public StringFileFilter( String aPattern ) {
		patternString = new String( aPattern );
		pattern = buildCompiledPattern( patternString );
	}
	
	private Pattern buildCompiledPattern( String aPattern ) {
		String translatedPattern = "";
		
		for ( int i = 0; i < aPattern.length(); i++ ) {
			char c = aPattern.charAt( i );
			if ( c == '*' ) {
				translatedPattern += "(.*)";
			} else if ( c == '?' ) {
				translatedPattern += ".";
			} else if ( c == '.' ) {
				translatedPattern += "\\.";
			} else {
				translatedPattern += c;
			}
		}
		
		return Pattern.compile( translatedPattern );
	}
	
	public String getRegularExpession() {
		return pattern.pattern();
	}
	
	public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}
		Matcher mat = pattern.matcher( f.getName() );
		if ( mat.matches() ) {
			return true;
		} else {
			return false;
		}
	}
}
	
